
#include "debug.h"

#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <windows.h>

//----------------------------------------------------------------------------------
// Trace
//----------------------------------------------------------------------------------
// 
// 07-Apr-2002
void _trace(char *function,char *file,long line,char *text) {
	char buffer[512];
	sprintf(buffer, "[TRACE] %s %s %i: %s\n",function,file,line,text);
	OutputDebugString(buffer);
}

//----------------------------------------------------------------------------------
// _CodePosition
//----------------------------------------------------------------------------------
// Returns a string with the actual codeposition
// 22.09.2000
char *_codePosition(char *file,long line) {
	static char b[256];
	sprintf(b,"[FILE] %s   [LINE] %i",file,line);
	return b;
}

//----------------------------------------------------------------------------------
// _PrintDebugString
//----------------------------------------------------------------------------------
// Prints a debug string
// 22.09.2000
void _printDebugString(char *text,char *file,long line) {
	char buffer[512];
	sprintf(buffer, "[MSG] %s (%s %i)\n",text,file,line);
	OutputDebugString(buffer);
}

//----------------------------------------------------------------------------------
// FatalError
//----------------------------------------------------------------------------------
// Fatal Error
// 22.09.2000
void __cdecl fatalError(char *text, ...) {
	static char textbuffer[2048];
	va_list args;
	va_start(args,text);
	vsprintf(textbuffer, text,args);
	va_end(args);

	char buffer[512];
	sprintf(buffer, "[FATAL] %s\n",textbuffer);
	OutputDebugString(buffer);

	exit(1);			//TODO: clean shutdown
}


//----------------------------------------------------------------------------------
// _Assert
//----------------------------------------------------------------------------------
// 22.09.2000
void _assert(bool boolValue,char *string,char *file, long line) {
	if(boolValue)
		return;

	char buffer[512];
	sprintf(buffer, "[ASSERT] %s (%s %i)",string,file,line);
	OutputDebugString(buffer);
}
