
#pragma once

#include <string.h>

#define PrintDebugString(x) _printDebugString((x),__FILE__,__LINE__)
#define CodePosition() _codePosition(__FILE__,__LINE__)

#ifdef _DEBUG
  #define assert(x) _assert((x),#x,__FILE__,__LINE__)
  #define TODO(x) _printDebugString((x),__FILE__,__LINE__)
  #define TRACE(x) _trace(__FUNCTION__,__FILE__,__LINE__,(x))
#else
  #define assert(x)
  #define TODO(x) 
  #define TRACE(x)
#endif


char *_codePosition(char *file, long line);
void _printDebugString(char *text,char *file,long line);
void __cdecl fatalError(char *text,...);
void _assert(bool boolValue,char *string,char *file, long line);
void _trace(char *function,char *file,long line,char *text);
